<?php
session_start();

require "autoload.php";
use Abraham\TwitterOAuth\TwitterOAuth;

// Cargamos la configuración de Twitter.
require('config.php');

// En la página de callback comprobamos si el Request Token que nos devuelve en el callback desde Twitter
//  coincide con el que tenemos grabado en la variable de sesión.
if (isset($_REQUEST['oauth_token']) && $_REQUEST['oauth_token'] !== $_SESSION['oauth_token']) {
    die('Error en la autenticación.');
}

// Si llega aquí se supone que el usuario se ha autenticado correctamente y solamente
// nos falta intercambiar los Request Token por los Access Token ("el Pase Definitivo")
// que nos permitirán acceder a Twitter como ese usuario recién autenticado.

// Creamos de nuevo la conexión a Twitter pero en este caso pasamos: 
// el Request_token y Request_token_secret.

$conexion = new TwitterOAuth(CONSUMER_KEY, CONSUMER_SECRET, $_SESSION['oauth_token'], $_SESSION['oauth_token_secret']);

// Si la conexión se ha realizado correctamente entonces ya podemos finalmente
// solicitar el intercambio de los Request Token por Access Token (el "Pase Definitivo").

// Para solicitar el Access Token necesitamos enviar el Código de Verificación (oauth verifier) recibido en el callback.php
$access_token = $conexion->oauth("oauth/access_token", array("oauth_verifier" => $_REQUEST['oauth_verifier']));

echo "<h2>Autenticación realizada con éxito.</h2>";
print_r($access_token);

// Ahora es cuando guardaríamos en la base de datos o en una sesión los access_token y access_token_secret de ese usuario.
$_SESSION['access_token'] = $access_token['oauth_token'];
$_SESSION['access_token_secret'] = $access_token['oauth_token_secret'];
$_SESSION['usuario_twitter'] = $access_token['screen_name'];

//echo $_SESSION['access_token']['screen_name'];